package cn.sh.ideal.util;

import java.security.MessageDigest;

public class Md5Utils {


    /**
     * sdk取号接口
     * 规则: userId + appId + 一键登录token + appSecret; md5 32位小写加密4次
     *
     * @param userId    userId
     * @param appId     appId
     * @param appSecret appSecret
     * @return sign签名
     */
    public static String getMobilePhone(String userId, String appId, String token, String appSecret) {
        String str = userId + appId + token + appSecret;
        try {
            return getMd5Sign(str, 0, 4);
        } catch (Exception ignored) {
        }

        return "";
    }

    /**
     * 循环加密
     *
     * @param str 要加密的串
     * @param i   递归计数
     * @param j   需要加密次数
     * @return 加密后的串
     * @throws Exception 异常
     */
    private static String getMd5Sign(String str, int i, int j) throws Exception {
        if (i == j) {
            return str;
        }
        return getMd5Sign(Md5Utils.md5Encrypt(str), i += 1, j);
    }

    /**
     * MD5方法
     *
     * @param text 明文
     * @return 密文
     * @throws Exception
     */
    public static String md5Encrypt(String text) throws Exception {
        byte[] bytes = text.getBytes();

        MessageDigest messageDigest = MessageDigest.getInstance("MD5");
        messageDigest.update(bytes);
        bytes = messageDigest.digest();

        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < bytes.length; i++) {
            if ((bytes[i] & 0xff) < 0x10) {
                sb.append("0");
            }
            sb.append(Long.toString(bytes[i] & 0xff, 16));
        }
        return sb.toString().toLowerCase();
    }

}
